#ifndef KOORD_H
#define KOORD_H

/**
 * file: koord.h
 *
 * Koord segdobjektum
 *
 */

/// Cellarcs koordintinak kezelshez
/// Koord osztly minden rsze publikus.
struct Koord {
public:
    enum Irany { fel, jobbra, le, balra };  /// tpus az eltolshoz
    int i;              /// sor
    int j;              /// oszlop

	/// Konstruktor:
	/// @param i - sor index
	/// @param j - oszlop index
    Koord(int i = 0, int j = 0) :i(i), j(j) {}

	/// sszehasonlts
	/// @param k - jobb oldali operandus
	/// @return true - ha mindkt koordinta azonos
	bool operator==(const Koord& k) const {
		return i == k.i && j == k.j;
	}

    /// Adott irnynak megfelen lpve j pozicit ad
    /// @param ir - irny
    /// @return j pozci
    Koord lep(Irany ir) const;
};

#endif
