/*
 * file: memcheck.h
 * A memriaszivrgs detektl funkcikhoz szksges definicik
 * Ezt a rszt nem fontos megrtenie
 */
#if defined(TRACE)              // Ha Peregi-fle trace van
# define _CrtDumpMemoryLeaks()
# define _StartMemoryCheck()
#elif defined(_MSC_VER)         // Ha Visual Studio
# define _CRTDBG_MAP_ALLOC
# include <stdlib.h>
# include <crtdbg.h>
# define _StartMemoryCheck()
#elif defined(__GNUC__)         // Ha GNU C
# include <malloc.h>
namespace _memcheck {
  static int uordblks; // ebben taroljuk az indulaskor lefoglalt blokkok szamat
}
# if defined(__MINGW32_VERSION)
#   define _CrtDumpMemoryLeaks()  
#   define _StartMemoryCheck()
# elif __GLIBC__ >= 2 
#   include <mcheck.h>
#   define _StartMemoryCheck()    mcheck_pedantic(NULL); mtrace(); _memcheck::uordblks = mallinfo().uordblks;  
#   define _CrtDumpMemoryLeaks()  mcheck_check_all(); \
                                  if (_memcheck::uordblks != mallinfo().uordblks) fprintf(stderr, "Memory leaks!\n"); 
# else 
#   define _StartMemoryCheck()    
#   define _CrtDumpMemoryLeaks()  { struct mallinfo m = mallinfo(); \
                                  if (m.uordblks > 48 || m.usmblks) fprintf(stderr, "Memory leaks! %d %d\n", m.uordblks, m.usmblks); }
# endif
#else				// nem tudjuk milyen fordt, nem csinlunk semmit0
# define _CrtDumpMemoryLeaks()  
# define _StartMemoryCheck()
#endif

