/**
 * file: obj.cpp
 *
 * Obj objektum s leszrmazottainak megvalstsa
 *
 */

#include "obj.h"
#include "memtrace.h"

/// Kisebb/nagyobb hal vagy vz keresse. Elszr halat keres.
/// @param pos - kezd pozci
/// @param oc - ocean
/// @param kisebb - true: kisebbet, false: nagyobbat keres
/// @return - megtallt pozcio - ha nincs, rvnytelen
Koord Obj::keres(const Koord& pos, Ocean& oc, bool kisebb) const {
    const Koord noPos(-1,-1);			// nem ltez pozci
    Koord talalt = noPos;				// nem tallt semmit
    for (int i = 0; i < 4; i++) {       // kihasznljuk az enum tulajdonsgt
        Koord ujPos = pos.lep(Koord::Irany(i));
        if (oc.ervenyes(ujPos)) {
            int m = oc.getObj(ujPos)->getmeret();
            if (m == 0) {
                if (talalt == noPos) talalt = ujPos;      // megjegyzi a vz helyt
            } else if ((kisebb && m < meret) || (!kisebb && m > meret)) {
                return ujPos;
            }
        }
    }
    return talalt;
}
