#ifndef OBJ_H
#define OBJ_H

/**
 * file: obj.h
 *
 * Obj Alapobjektum.
 *
 */
#include "koord.h"
#include "ocean.h"

class Ocean;		/// Eldeklarci. A krkrs include miatt kell

/// s objektum.
class Obj {
protected:
    char nev;       /// Objektum neve
    int meret;      /// nagyobb megeszi a kisebbet
    int iter;       /// Iterci szmllja
    bool ittaveg;   /// megsznst jelz flag
public:
	/// Kontruktor:
	/// @param nev - nv 1 char
	/// @param meret - hal mrete (ereje)
    Obj(char nev, int meret = 0)
        :nev(nev), meret(meret), iter(0), ittaveg(false) {}

    /// Nv lekrdezse
    /// @return - nev
    char getnev() const { return nev; }

    /// Mret lekrdezse
    /// @return - meret
    char getmeret() const { return meret; }

    /// ittaveg flag - ha az objektumot meg kell semmisteni
    /// @return - ittaveg
    bool is_vege() const { return ittaveg; }

    /// Kisebb/nagyobb hal vagy vz keresse. Elszr halat keres.
    /// @param pos - kezd pozci
    /// @param oc - ocean
    /// @param kisebb - true: kisebbet, false: nagyobbat keres
    /// @return - megtallt pozci - ha nincs, rvnytelen
    Koord keres(const Koord& pos, Ocean& oc, bool kisebb = true) const;

    /// Viselkedst megvalst fggvny
    /// Nem absztrakt, hogy ne kelljen megvalstani mindentt
	/// @param pos - pozici
    /// @param oc - cen
	/// @param it - itercis lpsszm
	virtual void lep(const Koord& pos, Ocean& oc, int it) {}

	/// Destruktor:
	/// Virtulis, hogy a leszrmazottaknak is meghvdjon
	virtual ~Obj() {}
};

#endif

