#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <iterator>

using std::vector;
using std::string;
using std::map;
using std::ostream_iterator;

using std::cin;
using std::cout;
using std::endl;
/*
 * A standard inputról beolvasott szövegbõl kigyûjtjük a
 * szavakat, és kiírjuk az elõfordulási statisztikájukat.
 * Szó: whitespace-szel határolt karaktersorozat.
 * Ha a szó tartalmaz szájegyet, akkor azt elhagyjuk belõle
 * Kovacs12Janos -> KovacsJanos
 */

bool isDigit(char ch) {  return isdigit(ch) != 0; }

int main() {

	map<string, int> szamlalo;	// itt tároljuk a statisztikát
	string szo;					// munkaváltozó a beolvasáshoz

    while (cin >> szo) {		// olvasunk whitespace-ig
		// a számjegyekre haragszunk, ezért eldobjuk azokat
		string::iterator vege =
		        remove_if(szo.begin(), szo.end(), isDigit);
		szo.erase(vege, szo.end());
		// ha maradt valami számolunk
		if (!szo.empty())
			szamlalo[szo] += 1;
	}

	// Kiírjuk a szavakat és az elõfordulási számot.
	// Betesszük egy vektorba a szavakat. (A map miatt rendezett)
	vector<string> szavak;
	cout << "Szavak gyakorisaga:" << endl;
	for (map<string, int>::iterator it = szamlalo.begin();
                                       it != szamlalo.end(); it++) {
		cout << it->first << ": " << it->second << endl;
		szavak.push_back(it->first);
	}

	// Kiírjuk a szavakat a vektorból.
	cout << "Szavak rendezve:" << endl;
	ostream_iterator<string> out_it(cout, ",");
	copy(szavak.begin(), szavak.end(), out_it);

	// És fordítva is lerendezzük.
	sort(szavak.begin(), szavak.end(), std::greater<string>());

	cout << endl << "Szavak forditva:" << endl;
	copy(szavak.begin(), szavak.end(), out_it);
}
